# Bewege einen OWIS Motor (Nummer <which>) um die Distanz <dist>
# Damit die richtigen Einheiten gefahren werden, mssen die Motoren richtig
# 	mittels owisinit initialisiert werden
# Weicht der Rueckgabewert von der gewnschten Strecke ab, ist ein Fehler
#	aufgetreten 
set OWIS_MOTSTR {X Y Z R}

# Vorbelegung Schrittweitentabelle:
set OWIS_STEPS {1 1 1 1}

# maximale Anzahl Schritte pro Fahrbefehl
set OWIS_MAX_STEPS 65535


proc owisinit {which steps} {
	global OWIS_STEPS 
	
	set OWIS_STEPS [lreplace $OWIS_STEPS $which $which $steps]
}


proc movmot {which dist} {
    global OWIS_MOTSTR OWIS_STEPS OWIS_MAX_STEPS

	set absval [expr abs ($dist)]
	set steps [expr {$absval / [lindex $OWIS_STEPS $which]}]
	set steps [expr int ($steps)]

# schaue, ob der Fahrbefehl in einem oder geteilt verschickt werden mu
	while { $steps > $OWIS_MAX_STEPS } {
		if { $dist < 0 } {
			set newdist [expr -$OWIS_MAX_STEPS * [lindex $OWIS_STEPS $which]]
			if { [movmot $which $newdist] != $newdist} {
				return 0
			} 
			set steps [expr $steps - $OWIS_MAX_STEPS]
		} else {
			set newdist [expr -$OWIS_MAX_STEPS * [lindex $OWIS_STEPS $which]]
			if { [movmot $which $newdist] != $newdist} {
				return 0
			}
			set steps [expr $steps - $OWIS_MAX_STEPS]
		}
	}
# konstruiere Fahrbefehl
	append weg [lindex $OWIS_MOTSTR $which] [expr {($dist < 0) ? "<" : ">"}]\
	           [format "%d %d" [expr {$steps / 256}] [expr {$steps % 256}]]
# schicke Fahrbefehl
	puts $weg
	return [moterr $which $dist]
}


# Lies Motorstatusbyte und pass auf, da kein Fehler auftritt:
proc moterr {which dist} {

	return $dist
}

        